/// <reference types="node" />
import { Result } from "ts-results";
import { RC } from "../rc.js";
/**
 * Overwrite the complete payload. partialUpdate property is mandatory.
 */
export interface writeCompletePayload {
    payload: RC;
    partialUpdate?: false;
}
/**
 * Partially update the payload. This implies not to rewrite the content of the file when enabled.
 **/
export interface writePartialPayload {
    payload: Partial<RC>;
    partialUpdate: true;
}
export declare type writeOptions = writeCompletePayload | writePartialPayload;
export declare function write(location: string | undefined, options: writeOptions): Promise<Result<void, NodeJS.ErrnoException>>;
