/**
 * Symbols used internally within ts-pattern to construct and discriminate
 * Guard, Not, and Select, and AnonymousSelect patterns
 *
 * Symbols have the advantage of not appearing in auto-complete suggestions in
 * user defined patterns, and eliminate the admittedly unlikely risk of property
 * overlap between ts-pattern internals and user defined patterns.
 *
 * These symbols have to be visible to tsc for type inference to work, but
 * users should not import them
 * @module
 * @private
 * @internal
 */
/** @internal This symbol should only be used by ts-pattern's internals. */
export declare const PatternKind: unique symbol;
export declare type PatternKind = typeof PatternKind;
/** @internal This symbol should only be used by ts-pattern's internals. */
export declare const Guard: unique symbol;
export declare type Guard = typeof Guard;
/** @internal This symbol should only be used by ts-pattern's internals. */
export declare const Not: unique symbol;
export declare type Not = typeof Not;
/** @internal This symbol should only be used by ts-pattern's internals. */
export declare const Select: unique symbol;
export declare type Select = typeof Select;
export declare const AnonymousSelectKey = "@ts-pattern/__anonymous-select-key";
export declare type AnonymousSelectKey = typeof AnonymousSelectKey;
